#include <sys/epoll.h>
#include "../Conn.h"

int main(void)
{
	int efd, i, n, fd;
	char buf[128];
	struct sockaddr_in s, c;
	int server, client;
	int v, ret, sock_len, c_len;
	struct epoll_event event;
	struct epoll_event status[32];

	efd = epoll_create(64);
	if (efd == -1) {
		perror("Cannot create epoll socket!");
		return 1;
	}

	memset(&s, 0, sizeof(s));
	s.sin_family = AF_INET;
	s.sin_addr.s_addr = htonl(INADDR_ANY);
	s.sin_port = htons(10001);
	sock_len = sizeof(s);

	server = socket(PF_INET, SOCK_STREAM, 0);
	if (server < 0) {
		perror("socket");
		return 1;
	}

	v = 1;
	setsockopt(server, SOL_SOCKET, SO_REUSEADDR, &v, sizeof(v));

	ret = bind(server, (struct sockaddr *) &s, sock_len);
	if (ret < 0) {
		perror("bind");
		return 1;
	}

	listen(server, 128);

	event.data.fd = server;
	event.events = EPOLLIN;
	ret = epoll_ctl(efd, EPOLL_CTL_ADD, server, &event);
	if (ret != 0) {
		perror("epoll_ctl");
		return 1;
	}

	while (1) {
		ret = epoll_wait(efd, &status[0], 32, -1);
		if (ret == -1) {
			perror("epoll_wait");
			return 1;
		}

		printf("epoll_wait returned %d\n", ret);

		if (ret == 0)
			continue;

		for (i = 0; i < ret; i++) {
			printf("%03d\t%x\t%d\n",
				i, status[i].events, status[i].data.fd);

			if (status[i].events & EPOLLIN) {
				if (status[i].data.fd == server) {
					c_len = sizeof(struct sockaddr);
					client = accept(server, (struct sockaddr *) &c, &c_len);
					printf("Incomming connection, new_fd=%d!\n", client);

				        event.data.fd = client;
				        event.events = EPOLLIN | EPOLLOUT;
				        ret = epoll_ctl(efd, EPOLL_CTL_ADD, client, &event);
				        if (ret != 0) {
						perror("epoll_ctl client");
						return 1;
					}
			        } else {
					n = recv(status[i].data.fd, buf, sizeof(buf), 0);
					printf("Incoming data (%d bytes) [%s]!\n",
						n, buf);
				}
			}
		}
	}

	return 0;
}
